/**
 * http 请求封装
 * @author tangsj
 * @param {*} url  请求地址
 * @param {*} options 请求参数
 */
import config from '../config';
import utils from '../utils';
// import createSign from "./createSignSdk.js"
import randomString from '../utils/randomString';
import CryptoJS from 'crypto-js';

// 记录请求中的请求数，控制loading显示
let requestCount = 0;
let hasError = false;
let tokenUrl = config.tokenUrl
let apiRoot = config.apiRoot
let invalid = false;

export function fetch(url, options) {
	let token = uni.getStorageSync('token')
	const header = {};
	header['token'] = token;
	header['content-type'] = 'application/x-www-form-urlencoded';

	options = Object.assign({
		method: 'GET',
		data: {},
		holdTip: false,
	}, options);

	return new Promise((resolve, reject) => {

		uni.request({
			url: `${config.url}${url}`,
			data: options.data,
			method: options.method,
			header,
			success: (res) => {
				console.log(res);
				if (res.statusCode == 200) {
					
					let resData = res.data
					let aesResObj
					if (resData && typeof(resData) === 'string') {
						// console.log('resultCryptoJS');
						aesResObj = resultCryptoJS(resData, res)
						// return resolve(aesResObj || {});
						// console.log(decryptedFn());
					} else {
						aesResObj = res
					}
					console.log(aesResObj);
					if (aesResObj.data.code == -2) {
						uni.showToast({
							icon: "none",
							title: '登录失效，请重新登录',
							duration: 2000
						})
					} else {
						if (aesResObj.data.status == 'NO') {
							uni.showToast({
								icon: "none",
								title: aesResObj.data.info,
								duration: 2000
							})
							reject(aesResObj.data)
						} else {
							resolve(aesResObj.data);
						}
					}
				} else {
					if (options.msg) {
						uni.showToast({
							icon: "none",
							title: options.msg
						})
					}
				}
			},
			fail: () => {
				// hasError = true;

				uni.showToast({
					title: '网络较慢，请稍后再试',
					icon: 'none',
				});

				reject({
					msg: '网络较慢，请稍后再试',
				});
			},
			complete: () => {
				// requestCount -= 1;
			},
		});
	});
}


const resultCryptoJS = (resData, res) => {
	let decryptedFn = (word) => {
		// let word = 'MYXCBCRv+hJq3/vG7SqtDQ==';
		let keyStr = 'ba8db3a7872eb0a0';
		let ivStr = '13dbe44ba54612ff';
		let key;
		let iv;

		if (keyStr) {
			key = CryptoJS.enc.Utf8.parse(keyStr);
			iv = CryptoJS.enc.Utf8.parse(ivStr);
		}
		const base64 = CryptoJS.enc.Base64.parse(word);
		const src = CryptoJS.enc.Base64.stringify(base64);
		const decrypted = CryptoJS.AES.decrypt(src, key, {
			iv, // 偏移量
			mode: CryptoJS.mode.CBC,
			padding: CryptoJS.pad.Pkcs7
			// padding: CryptoJS.pad.ZeroPadding
		});

		const decryptedStr = decrypted.toString(CryptoJS.enc.Utf8);

		return decryptedStr.toString();
	}
	let aesRes = decryptedFn(resData)
	let aesResObj
	try {
		aesResObj = {
			...res,
			data: JSON.parse(aesRes)
		}
	} catch (e) {
		// console.log(e);
		aesResObj = {
			...res
			// ...res.data,
			// data: res.data.data || {}
		}
		//TODO handle the exception
	}
	return aesResObj
}
const generateRandomString = (length) => {
	const characters = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
	let result = '';
	for (let i = 0; i < length; i++) {
		const randomIndex = Math.floor(Math.random() * characters.length);
		result += characters[randomIndex];
	}
	return result;
}
// const getDataSign = (datas) => {
// 	let arr = []
// 	for (let key in datas) {
// 		if (datas[key]) {
// 			arr.push({
// 				key: key,
// 				val: datas[key]
// 			})
// 		}
// 	}

// 	// arr.sort((a, b) => a.key.charCodeAt(0) - b.key.charCodeAt(0))
// 	arr.sort((a, b) => a.key.localeCompare(b.key))
// 	let res = arr.map(item => `${item.key}=${item.val}`)
// 	// console.log(arr);
// 	let stringA = res.join('&')
// 	let stringSignTemp = stringA + "&key=2B39F1EBCD77E7917AA28BAA8C3AA71A"
// 	// console.log(stringSignTemp);
// 	let sign = md5(stringSignTemp).toUpperCase()
// 	// console.log(sign);
// 	return sign
// }


const http = {
	get(url, data = {}, options = {}) {
		const dataParams = data
		try {
			if (!dataParams.params) {
				dataParams.params = {}
			}
			dataParams.params.randstr = randomString.randomStrings(6);
			dataParams.params.timestamp = parseInt(new Date().getTime() / 1000);
			dataParams.params.platform = 'mini'; // 平台标识
			// const signs = createSign({
			// 	...dataParams.params,
			// });
			// dataParams.params.sign = signs.sign;
		} catch (e) {
			console.log(e);
		}
		return fetch(url, {
			method: 'GET',
			data: dataParams.params,
			...options,
		});
	},
	post(url, data = {}, options = {}) {
		const dataParams = data
		if (!dataParams.params) {
			dataParams.params = {}
		}
		dataParams.params.randstr = randomString.randomStrings(6);
		dataParams.params.timestamp = parseInt(new Date().getTime() / 1000);
		dataParams.params.platform = 'mini'; // 平台标识
		if (dataParams.params) {
			// try {
			// 	let signsJson = {}
			// 	Object.keys(dataParams).forEach(item => {
			// 		if (item !== 'params') {
			// 			signsJson[item] = dataParams[item]
			// 		} else {
			// 			signsJson = {
			// 				...signsJson,
			// 				...dataParams[item]
			// 			}
			// 		}
			// 	})
			// 	const signs = createSign(signsJson);
			// 	dataParams.params.sign = signs.sign;
			// } catch (e) {
			// 	console.log(e);
			// }
			// 将param放到url 参数里面
			const query = utils.buildQueryString(dataParams.params);
			url += `?${query}`;
			delete dataParams.params;
		}
		console.log(dataParams)
		return fetch(url, {
			method: 'POST',
			data: dataParams,
			...options,
		});
	},
};

export default http;